/***************************************************************
* L&L - Labyrinths & Legends
* Copyright (c) 1993-2007 YOSHIMURA Tomohiko All rights reserved.
* 
* Created by BowKenKen
*   URL: https://sourceforge.jp/projects/lnl/
* 
* License is GPL
* 
* ܥץϥե꡼եȥǤ
* ʤϡ Free Software Foundation ɽ
*  GNU ̸ͭѵΡ֥С󣲡
* ϤʹߤγƥС椫餤줫򤷡
* ΥС˽äܥץ
* ۤޤѹ뤳ȤǤޤ
* 
* ܥץͭѤȤϻפޤۤˤäƤϡ
* ԾڤŪŬˤĤƤΰۤݾڤޤ,
* ʤݾڤԤʤޤ
* ܺ٤ˤĤƤ GNU ̸ͭѵɤߤ
* 
* ʤϡܥץȰ GNU ̸ͭѵ
* μ̤äƤϤǤǤʤϡ
*   Free Software Foundation, Inc.,
*   59 Temple Place, Suite 330, Boston, MA 02111-1307, USA
* ؼ񤤤Ƥ
* 
* $Id: Key.cpp,v 1.6 2007/02/20 01:55:22 bowkenken Exp $
***************************************************************/

#include "gmain.h"
#include "curs.h"
#include "draw.h"
#include "draw-prot.h"

#include "Key.h"
#include "GlobalVar.h"

////////////////////////////////////////////////////////////////
// WideStudio ΥХ롦եåΥϥɥ
// long keyCode : 
// WSCbool flagOn : Υ󡿥
// return : false ʤ饭Ϥ˴
////////////////////////////////////////////////////////////////

#ifdef D_WS

static WSCbool handler( long keyCode, WSCbool flagOn )
{
	long key = '\0';

	if( !flagOn )
		return true;

	if( (WSK_a <= keyCode) && (keyCode <= WSK_z) ){
		if( WSGIappKeyboard()->withCntl() ){
			key = keyCode - WSK_a + 1;
		} else {
			key = keyCode;
		}

		gKey.setChar( key, true );
		return false;
	}
	if( (WSK_A <= keyCode) && (keyCode <= WSK_Z) ){
		if( WSGIappKeyboard()->withCntl() ){
			key = keyCode - WSK_A + 1;
		} else {
			key = keyCode;
		}

		gKey.setChar( key, true );
		return false;
	}

	switch( keyCode ){
	// 롦
	case WSK_Up:
		key = '8';
		break;
	case WSK_Down:
		key = '2';
		break;
	case WSK_Left:
		key = '4';
		break;
	case WSK_Right:
		key = '6';
		break;
	// 롦
	case WSK_Insert:
		key = '/';
		break;
	case WSK_Home:
		key = '*';
		break;
	case WSK_Page_Up:
		key = '-';
		break;
	case WSK_Page_Down:
		key = '+';
		break;
	case WSK_Delete:
		key = 'H' - '@';
		break;
	case WSK_End:
		key = '.';
		break;
	// ƥ󡦥
	case WSK_KP_0:
		key = '0';
		break;
	case WSK_KP_1:
		key = '1';
		break;
	case WSK_KP_2:
		key = '2';
		break;
	case WSK_KP_3:
		key = '3';
		break;
	case WSK_KP_4:
		key = '4';
		break;
	case WSK_KP_5:
		key = '5';
		break;
	case WSK_KP_6:
		key = '6';
		break;
	case WSK_KP_7:
		key = '7';
		break;
	case WSK_KP_8:
		key = '8';
		break;
	case WSK_KP_9:
		key = '9';
		break;
	// ƥ󡦥
	case WSK_KP_Enter:
		key = 'M' - '@';
		break;
	case WSK_KP_Decimal:
		key = '.';
		break;
	case WSK_KP_Divide:
		key = '/';
		break;
	case WSK_KP_Multiply:
		key = '*';
		break;
	case WSK_KP_Subtract:
		key = '-';
		break;
	case WSK_KP_Add:
		key = '+';
		break;
	// ե󥯥󡦥
	case WSK_F1:
		key = KEY_F( 1 );
		break;
	case WSK_F2:
		key = KEY_F( 2 );
		break;
	case WSK_F3:
		key = KEY_F( 3 );
		break;
	case WSK_F4:
		key = KEY_F( 4 );
		break;
	case WSK_F5:
		key = KEY_F( 5 );
		break;
	case WSK_F6:
		key = KEY_F( 6 );
		break;
	case WSK_F7:
		key = KEY_F( 7 );
		break;
	case WSK_F8:
		key = KEY_F( 8 );
		break;
	case WSK_F9:
		key = KEY_F( 9 );
		break;
	case WSK_F10:
		key = KEY_F( 10 );
		break;
	case WSK_F11:
		key = KEY_F( 11 );
		break;
	case WSK_F12:
		key = KEY_F( 12 );
		break;
	case WSK_F13:
		key = KEY_F( 13 );
		break;
	case WSK_F14:
		key = KEY_F( 14 );
		break;
	case WSK_F15:
		key = KEY_F( 15 );
		break;
	// ¾
	case WSK_bracketleft:
		if( WSGIappKeyboard()->withCntl() )
			key = 'H' - '@';
		else
			key = '[';
		break;
	case WSK_Tab:
		key = 'I' - '@';
		break;
	case WSK_Escape:
		key = 'H' - '@';
		break;
	case WSK_Shift_L:
	case WSK_Control_L:
	case WSK_Alt_L:
	case WSK_Meta_L:
		key = '\0';
		break;
	default:
		key = keyCode;
		break;
	}

	gKey.setChar( key, true );
	return false;
}

#endif // D_WS

#ifdef D_GTK

gboolean handleKeyPress(
	GtkWidget *widget,
	GdkEventKey *event,
	gpointer user_data
)
{
	long key = event->keyval;

	if( event->state & GDK_CONTROL_MASK ){
		if( (GDK_a <= key) && (key <= GDK_z) )
			key = key - GDK_a + 1;
		if( (GDK_A <= key) && (key <= GDK_Z) )
			key = key - GDK_A + 1;
	}

	switch( key ){
	case GDK_Shift_L:
	case GDK_Shift_R:
	case GDK_Control_L:
	case GDK_Control_R:
	case GDK_Caps_Lock:
	case GDK_Shift_Lock:
	case GDK_Meta_L:
	case GDK_Meta_R:
	case GDK_Alt_L:
	case GDK_Alt_R:
		return 1;
	case GDK_Escape:
		key = 'H' - '@';
		break;
	case GDK_BackSpace:
		key = 'H' - '@';
		break;
	case GDK_Linefeed:
		key = 'M' - '@';
		break;
	case GDK_Return:
		key = 'M' - '@';
		break;
	case GDK_Tab:
		key = 'I' - '@';
		break;
	// 롦
	case GDK_Up:
		key = '8';
		break;
	case GDK_Down:
		key = '2';
		break;
	case GDK_Left:
		key = '4';
		break;
	case GDK_Right:
		key = '6';
		break;
	// 롦
	case GDK_Insert:
		key = '/';
		break;
	case GDK_Home:
		key = '*';
		break;
	case GDK_Page_Up:
		key = '-';
		break;
	case GDK_Page_Down:
		key = '+';
		break;
	case GDK_Delete:
		key = 'H' - '@';
		break;
	case GDK_End:
		key = '.';
		break;
	// ƥ󡦥
	case GDK_KP_0:
		key = '0';
		break;
	case GDK_KP_1:
		key = '1';
		break;
	case GDK_KP_2:
		key = '2';
		break;
	case GDK_KP_3:
		key = '3';
		break;
	case GDK_KP_4:
		key = '4';
		break;
	case GDK_KP_5:
		key = '5';
		break;
	case GDK_KP_6:
		key = '6';
		break;
	case GDK_KP_7:
		key = '7';
		break;
	case GDK_KP_8:
		key = '8';
		break;
	case GDK_KP_9:
		key = '9';
		break;
	// ƥ󡦥
	case GDK_KP_Enter:
		key = 'M' - '@';
		break;
	case GDK_KP_Decimal:
		key = '.';
		break;
	case GDK_KP_Divide:
		key = '/';
		break;
	case GDK_KP_Multiply:
		key = '*';
		break;
	case GDK_KP_Subtract:
		key = '-';
		break;
	case GDK_KP_Add:
		key = '+';
		break;
	// ƥ󡦥դΥ롦
	case GDK_KP_Insert:
		key = '/';
		break;
	case GDK_KP_Home:
		key = '*';
		break;
	case GDK_KP_Page_Up:
		key = '-';
		break;
	case GDK_KP_Page_Down:
		key = '+';
		break;
	case GDK_KP_Delete:
		key = 'H' - '@';
		break;
	case GDK_KP_End:
		key = '.';
		break;
	case GDK_KP_Up:
		key = '8';
		break;
	case GDK_KP_Down:
		key = '2';
		break;
	case GDK_KP_Left:
		key = '4';
		break;
	case GDK_KP_Right:
		key = '6';
		break;
	case GDK_KP_Space:
		key = ' ';
		break;
	case GDK_KP_Tab:
		key = 'I' - '@';
		break;
	case GDK_KP_Equal:
		key = '=';
		break;
	case GDK_F1:
	case GDK_F2:
	case GDK_F3:
	case GDK_F4:
	case GDK_F5:
	case GDK_F6:
	case GDK_F7:
	case GDK_F8:
	case GDK_F9:
	case GDK_F10:
	case GDK_F11:
	case GDK_F12:
	case GDK_F13:
	case GDK_F14:
	case GDK_F15:
	case GDK_F16:
	case GDK_F17:
	case GDK_F18:
	case GDK_F19:
	case GDK_F20:
	case GDK_F21:
	case GDK_F22:
	case GDK_F23:
	case GDK_F24:
	case GDK_F25:
	case GDK_F26:
	case GDK_F27:
	case GDK_F28:
	case GDK_F29:
	case GDK_F30:
	case GDK_F31:
	case GDK_F32:
	case GDK_F33:
	case GDK_F34:
	case GDK_F35:
		char buf[15 + 1];
		sprintf( buf, "&%2ld", key - GDK_F1 + 1 );
		gKey.setString( buf, true );

		return 1;
	}

	gKey.setChar( key, true );

	return 1;
}

#endif // D_GTK

////////////////////////////////////////////////////////////////
// Х롦եåΥϥɥϿ
////////////////////////////////////////////////////////////////

void Key::init()
{
#ifdef D_WS
	WSGIappKeyboard()->setGlobalKeyHook( handler );
#endif // D_WS

#ifdef D_GTK
	// ᥤ󡦥ɥؤΥ٥ȡϥɥ

	gtk_signal_connect( GTK_OBJECT( gMapWin ),
			"key-press-event",
			GTK_SIGNAL_FUNC( handleKeyPress ), NULL );

	// ˥塼ɥؤΥ٥ȡϥɥ

	gtk_signal_connect( GTK_OBJECT( gGuiMenu.mMenuWin ),
			"key-press-event",
			GTK_SIGNAL_FUNC( handleKeyPress ), NULL );
#endif // D_GTK
}

////////////////////////////////////////////////////////////////
// Хåե飱ʸФ
// return : 
////////////////////////////////////////////////////////////////

long Key::getChar()
{
	if( buf.getChars() <= 0 )
		return -1;

	long c = (long)(buf[0]);
	buf.deleteChar( 0 );

	return c;
}

////////////////////////////////////////////////////////////////
// Хåեˣʸɲ
// long c : 
// bool flagCheckClear : ԡȤХåե
//                       ޤʤͤˤ뤫
////////////////////////////////////////////////////////////////

void Key::setChar( long c, bool flagCheckClear )
{
	char s[4 + 1] = "";
	s[0] = c;
	s[1] = '\0';

	setString( s, flagCheckClear );
}

////////////////////////////////////////////////////////////////
// Хåեʸɲ
// WSCstring s : ʸ
// bool flagCheckClear : ԡȤХåե
//                       ޤʤͤˤ뤫
////////////////////////////////////////////////////////////////

void Key::setString( WSCstring s, bool flagCheckClear )
{
	if( flagCheckClear && g_flg_clr_key_buf ){
		static long gPreChar = -1;

		if( get_key_buf_char() == '\0' )
			gPreChar = -1;

		for( long i = 0; i < s.getChars(); i++ ){
			if( s[i] == gPreChar ){
				s.deleteChar( i );
				i--;
			} else {
				gPreChar = s[i];
			}
		}
	}

	if( s.getChars() <= 0 )
		return;
	if( s[0] == '\0' )
		return;

	switch( g_gui_key_kind ){
	case GUI_KEY_KIND_CONSOLE:
	case GUI_KEY_KIND_KEY_BUF_INTERRUPT:
		setStringKeyTab( s );
		break;
	case GUI_KEY_KIND_CLASS_KEY:
		buf += s;
		break;
	case GUI_KEY_KIND_MAX_N:
		break;
	}
}

////////////////////////////////////////////////////////////////
// Хåեʸɲ
// WSCstring s : ʸ
////////////////////////////////////////////////////////////////

void Key::setStringKeyTab( WSCstring s )
{
	char **tab = get_key_tab();

	for( ; s.getChars() > 0; s.deleteChar( 0 ) ){
		long c;
		c = s[0];

		bool bFlgTab;
		bFlgTab = true;

		if( c <= '\0' )
			bFlgTab = false;
		if( c >= KEY_TAB_MAX_N )
			bFlgTab = false;
		if( tab[c] == NULL )
			bFlgTab = false;

		if( bFlgTab ){
			set_key_buf_str( tab[c] );
		} else {
			WSCstring buf;
			buf = s;
			buf.cutString( 1 );

			set_key_buf_str( buf );
		}
	}

	set_flg_break_key( TRUE );
}
